NaCl runtime fixes
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve gc-descriptors
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17 with_mono_path_moonlight = MONO_PATH=$(mcs_topdir)/class/lib/moonlight_raw
18
19 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
20 RUNTIME_MOONLIGHT = $(with_mono_path_moonlight) $(top_builddir)/runtime/mono-wrapper
21
22 MKBUNDLE = \
23         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
24         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
25
26 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -nowarn:0162 -nowarn:0168 -nowarn:0219 -debug
27 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
28
29 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
30
31 STRESS_TESTS_SRC=       \
32         abort-stress-1.cs       \
33         abort-stress-2.cs       \
34         abort-stress-3.cs       \
35         domain-stress.cs        \
36         gchandle-stress.cs      \
37         monitor-stress.cs       \
38         thread-stress.cs        \
39         gc-stress.cs            \
40         exit-stress.cs          \
41         process-stress.cs       \
42         assembly-load-stress.cs
43
44 # Disabled until ?mcs is fixed
45 #       bug-331958.cs
46 BASE_TEST_CS_SRC=               \
47         bug-2907.cs             \
48         array-init.cs           \
49         arraylist.cs            \
50         assemblyresolve_event.cs        \
51         assemblyresolve_event3.cs       \
52         checked.cs              \
53         char-isnumber.cs        \
54         create-instance.cs      \
55         field-layout.cs         \
56         pack-layout.cs          \
57         pack-bug.cs             \
58         hash-table.cs           \
59         test-ops.cs             \
60         obj.cs                  \
61         test-dup-mp.cs          \
62         string.cs               \
63         stringbuilder.cs        \
64         switch.cs               \
65         outparm.cs              \
66         delegate.cs             \
67         bitconverter.cs         \
68         exception.cs            \
69         exception2.cs           \
70         exception3.cs           \
71         exception4.cs           \
72         exception5.cs           \
73         exception6.cs           \
74         exception7.cs           \
75         exception8.cs           \
76         exception10.cs          \
77         exception11.cs          \
78         exception12.cs          \
79         exception13.cs          \
80         exception14.cs          \
81         exception15.cs          \
82         exception16.cs          \
83         exception17.cs          \
84         typeload-unaligned.cs   \
85         struct.cs               \
86         valuetype-gettype.cs    \
87         typeof-ptr.cs           \
88         static-constructor.cs   \
89         pinvoke.cs              \
90         pinvoke2.cs             \
91         pinvoke3.cs             \
92         pinvoke11.cs            \
93         pinvoke13.cs            \
94         pinvoke17.cs            \
95         invoke.cs               \
96         invoke2.cs              \
97         runtime-invoke.cs               \
98         invoke-string-ctors.cs          \
99         reinit.cs               \
100         box.cs                  \
101         array.cs                \
102         enum.cs                 \
103         enum2.cs                \
104         property.cs             \
105         enumcast.cs             \
106         assignable-tests.cs     \
107         array-cast.cs           \
108         array-subtype-attr.cs   \
109         cattr-compile.cs        \
110         cattr-field.cs          \
111         cattr-object.cs         \
112         custom-attr.cs          \
113         double-cast.cs          \
114         newobj-valuetype.cs     \
115         arraylist-clone.cs      \
116         setenv.cs               \
117         vtype.cs                \
118         isvaluetype.cs          \
119         iface6.cs               \
120         iface7.cs               \
121         ipaddress.cs            \
122         array-vt.cs             \
123         interface1.cs           \
124         reflection-enum.cs      \
125         reflection-prop.cs      \
126         reflection4.cs          \
127         reflection5.cs          \
128         reflection-const-field.cs \
129         many-locals.cs          \
130         string-compare.cs       \
131         test-prime.cs           \
132         params.cs               \
133         reflection.cs           \
134         interface.cs            \
135         iface.cs                \
136         iface2.cs               \
137         iface3.cs               \
138         iface4.cs               \
139         iface-large.cs          \
140         virtual-method.cs       \
141         intptrcast.cs           \
142         indexer.cs              \
143         stream.cs               \
144         console.cs              \
145         shift.cs                \
146         jit-int.cs              \
147         jit-uint.cs             \
148         jit-long.cs             \
149         long.cs                 \
150         jit-ulong.cs            \
151         jit-float.cs            \
152         pop.cs                  \
153         time.cs                 \
154         appdomain.cs        \
155         appdomain1.cs           \
156         appdomain2.cs           \
157         appdomain-client.cs     \
158         appdomain-unload.cs \
159         appdomain-async-invoke.cs       \
160         loader.cs       \
161         pointer.cs              \
162         hashcode.cs             \
163         delegate1.cs            \
164         delegate2.cs            \
165         delegate3.cs            \
166         delegate5.cs            \
167         delegate6.cs            \
168         delegate7.cs            \
169         delegate8.cs            \
170         delegate9.cs            \
171         remoting1.cs            \
172         remoting2.cs            \
173         remoting3.cs            \
174         remoting4.cs            \
175         remoting5.cs            \
176         largeexp.cs             \
177         largeexp2.cs            \
178         marshalbyref1.cs        \
179         static-ctor.cs          \
180         inctest.cs              \
181         bound.cs                \
182         array-invoke.cs         \
183         test-arr.cs             \
184         decimal.cs              \
185         decimal-array.cs        \
186         marshal.cs              \
187         marshal1.cs             \
188         marshal2.cs             \
189         marshal3.cs             \
190         marshal5.cs             \
191         marshal6.cs             \
192         marshal7.cs             \
193         marshal8.cs             \
194         marshal9.cs             \
195         marshalbool.cs          \
196         marshal-valuetypes.cs   \
197         test-byval-in-struct.cs \
198         thread.cs               \
199         thread5.cs              \
200         thread6.cs              \
201         thread-static.cs        \
202         thread-static-init.cs   \
203         context-static.cs       \
204         float-pop.cs            \
205         interfacecast.cs        \
206         array3.cs               \
207         classinit.cs            \
208         classinit2.cs           \
209         synchronized.cs         \
210         async_read.cs           \
211         threadpool.cs           \
212         threadpool1.cs          \
213         threadpool-exceptions1.cs \
214         threadpool-exceptions2.cs \
215         threadpool-exceptions3.cs \
216         threadpool-exceptions4.cs \
217         threadpool-exceptions5.cs \
218         threadpool-exceptions6.cs \
219         threadpool-exceptions7.cs \
220         base-definition.cs      \
221         bug-27420.cs            \
222         bug-47295.cs            \
223         bug-46781.cs            \
224         bug-48015.cs            \
225         bug-42136.cs            \
226         bug-59286.cs            \
227         bug-70561.cs            \
228         bug-78311.cs            \
229         bug-78653.cs            \
230         bug-78656.cs            \
231         bug-77127.cs            \
232         bug-323114.cs           \
233         bug-Xamarin-5278.cs     \
234         interlocked.cs          \
235         cross-domain.cs         \
236         appdomain-exit.cs       \
237         delegate-async-exit.cs  \
238         delegate-delegate-exit.cs       \
239         delegate-exit.cs        \
240         finalizer-abort.cs      \
241         finalizer-exception.cs  \
242         finalizer-exit.cs       \
243         finalizer-thread.cs     \
244         main-exit.cs    \
245         main-returns-abort-resetabort.cs        \
246         main-returns-background-abort-resetabort.cs     \
247         main-returns-background-resetabort.cs   \
248         main-returns-background.cs      \
249         main-returns-background-change.cs       \
250         main-returns.cs         \
251         subthread-exit.cs       \
252         desweak.cs              \
253         cominterop.cs           \
254         exists.cs               \
255         handleref.cs    \
256         transparentproxy.cs \
257         dbnull-missing.cs       \
258         test-type-ctor.cs       \
259         soft-float-tests.cs     \
260         thread-exit.cs          \
261         finalize-parent.cs      \
262         assemblyresolve_event2.2.cs     \
263         interlocked-2.2.cs      \
264         pinvoke-2.2.cs          \
265         bug-78431.2.cs          \
266         bug-79684.2.cs          \
267         catch-generics.2.cs     \
268         event-get.2.cs          \
269         safehandle.2.cs         \
270         stackframes-async.2.cs          \
271         module-cctor-loader.2.cs        \
272         generics-invoke-byref.2.cs      \
273         generic-signature-compare.2.cs  \
274         generics-sharing.2.cs   \
275         shared-generic-methods.2.cs     \
276         shared-generic-synchronized.2.cs        \
277         generic-inlining.2.cs   \
278         generic-initobj.2.cs    \
279         generic-delegate.2.cs   \
280         generic-sizeof.2.cs     \
281         generic-virtual.2.cs    \
282         generic-interface-methods.2.cs  \
283         generic-array-type.2.cs \
284         generic-method-patching.2.cs    \
285         generic-static-methods.2.cs     \
286         generic-null-call.2.cs  \
287         generic-special.2.cs    \
288         generic-exceptions.2.cs \
289         generic-virtual2.2.cs   \
290         generic-valuetype-interface.2.cs        \
291         generic-getgenericarguments.2.cs        \
292         generic-type-builder.2.cs       \
293         generic-synchronized.2.cs       \
294         generic-delegate-ctor.2.cs      \
295         generic-array-iface-set.2.cs    \
296         generic-typedef.2.cs    \
297         generic-marshalbyref.2.cs       \
298         generic-xdomain.2.cs    \
299         bug-431413.2.cs \
300         bug-459285.2.cs \
301         generic-virtual-invoke.2.cs     \
302         bug-461198.2.cs \
303         generic-sealed-virtual.2.cs     \
304         generic-system-arrays.2.cs      \
305         generic-stack-traces.2.cs       \
306         generic-stack-traces2.2.cs      \
307         bug-472600.2.cs \
308         recursive-generics.2.cs \
309         bug-473482.2.cs \
310         bug-473999.2.cs \
311         bug-479763.2.cs \
312         bug-616463.cs   \
313         bug-80392.2.cs          \
314         dynamic-method-access.2.cs      \
315         dynamic-method-finalize.2.cs    \
316         bug-82194.2.cs  \
317         anonarray.2.cs  \
318         ienumerator-interfaces.2.cs     \
319         array-enumerator-ifaces.2.cs    \
320         generic_type_definition_encoding.2.cs \
321         generic_type_definition.2.cs    \
322         bug-333798.2.cs         \
323         bug-333798-tb.2.cs              \
324         bug-335131.2.cs         \
325         bug-322722_patch_bx.2.cs                \
326         bug-348522.2.cs         \
327         bug-340662_bug.cs       \
328         bug-322722_dyn_method_throw.2.cs        \
329         bug-389886-2.cs \
330         bug-325283.2.cs \
331         thunks.cs \
332         winx64structs.cs \
333         bug-349190.2.cs \
334         nullable_boxing.2.cs    \
335         valuetype-equals.cs     \
336         custom-modifiers.2.cs   \
337         bug-382986.cs   \
338         test-inline-call-stack.cs       \
339         bug-324535.cs   \
340         modules.cs      \
341         bug-81673.cs    \
342         bug-81691.cs    \
343         bug-80307.cs    \
344         bug-415577.cs   \
345         filter-stack.cs \
346         vararg2.cs      \
347         bug-389886-sre-generic-interface-instances.cs   \
348         bug-461867.cs   \
349         bug-461941.cs   \
350         bug-461261.cs   \
351         bug-400716.cs   \
352         bug-462592.cs   \
353         bug-459094.cs   \
354         generic-unloading.2.cs  \
355         generic-unloading-sub.2.cs      \
356         bug-467456.cs   \
357         appdomain-unload-callback.cs    \
358         bug-508538.cs   \
359         bug-472692.2.cs         \
360         gchandles.cs    \
361         interlocked-3.cs        \
362         interlocked-4.2.cs      \
363         appdomain-thread-abort.cs \
364         xdomain-threads.cs      \
365         w32message.cs   \
366         bug-544446.cs   \
367         gc-altstack.cs  \
368         large-gc-bitmap.cs      \
369         bug-561239.cs   \
370         bug-562150.cs   \
371         bug-575941.cs   \
372         bug-599469.cs   \
373         bug-389886-3.cs \
374         monitor.cs      \
375         dynamic-method-resurrection.cs  \
376         bug-666008.cs   \
377         bug-685908.cs   \
378         sgen-long-vtype.cs      \
379         delegate-invoke.cs      \
380         bug-696593.cs   \
381         bug-705140.cs   \
382         bug-1147.cs     \
383         mono-path.cs    \
384         bug-bxc-795.cs  \
385         bug-3903.cs     \
386         async-with-cb-throws.cs \
387         appdomain-unload-doesnot-raise-pending-events.cs        \
388         bug-6148.cs     \
389         assembly_append_ordering.cs     \
390         bug-10127.cs    \
391         allow-synchronous-major.cs
392
393 TEST_CS_SRC_DIST=       \
394         $(BASE_TEST_CS_SRC)     \
395         async-exc-compilation.cs \
396         filter-stack.cs \
397         finally_guard.cs
398
399 TEST_CS_SRC_GEN = \
400         runtime-invoke.gen.cs \
401         imt_big_iface_test.cs
402
403 if AMD64
404 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
405 # #651684
406 PLATFORM_DISABLED_TESTS = finally_guard.exe
407 else
408 if X86
409 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
410 else
411 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
412 endif
413 endif
414
415 if IA64
416 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
417 # bug #319249
418 PLATFORM_DISABLED_TESTS=exception17.exe
419 PLATFORM_DISABLED_TESTS+=winx64structs.exe
420 endif
421
422 if X86
423
424 if HOST_WIN32
425 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
426 endif
427
428 endif
429
430 if POWERPC
431 # bug #71274
432 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
433 endif
434
435 if ARM
436 PLATFORM_DISABLED_TESTS=filter-stack.exe
437 endif
438
439 if MIPS
440 # monitor.exe is racy
441 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
442 endif
443
444 if S390x
445 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
446 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
447 endif
448
449 if NACL_CODEGEN
450 # Tests that use Thread.Abort()
451 PLATFORM_DISABLED_TESTS= abort-stress-1.exe \
452                          abort-stress-2.exe \
453                          abort-stress-3.exe \
454                          appdomain-thread-abort.exe \
455                          async-exc-compilation.exe \
456                          bug-561239.exe \
457                          bug-70561.exe \
458                          finalizer-abort.exe \
459                          finally_guard.exe \
460                          main-returns-abort-resetabort.exe \
461                          main-returns-background-abort-resetabort.exe \
462                          thread6.exe \
463                          threadpool-exceptions5.exe \
464                          threadpool-exceptions6.exe
465
466 # Tests that rely on AppDomain.Unload
467 PLATFORM_DISABLED_TESTS+= appdomain-async-invoke.exe \
468                           appdomain-exit.exe \
469                           appdomain-unload-callback.exe \
470                           appdomain-unload.exe \
471                           domain-stress.exe \
472                           generic-unloading.2.exe \
473                           monitor.exe \
474                           remoting4.exe \
475                           threadpool-exceptions7.exe \
476                           xdomain-threads.exe
477
478 # pinvoke2 attaches a thread to the runtime, but
479 # doesn't 'unattach' it and it hangs in GC on exit
480 PLATFORM_DISABLED_TESTS+= pinvoke2.exe
481
482 # Tests that currently hang waiting for non-main threads
483 # to exit in NaCl, need to investigate.  Most are AppDomain
484 # creation and Delegate tests.
485 PLATFORM_DISABLED_TESTS+= appdomain1.exe \
486                           delegate9.exe \
487                           marshal-valuetypes.exe \
488                           cross-domain.exe \
489                           stackframes-async.2.exe \
490                           generic-marshalbyref.2.exe \
491                           generic-xdomain.2.exe \
492                           bug-415577.exe
493
494 # Tests that fail trying to write files (appdomain create mostly)
495 PLATFORM_DISABLED_TESTS+= bug-335131.2.exe \
496                           bug-349190.2.exe \
497                           bug-80307.exe \
498                           bug-462592.exe
499
500 # FIXME: don't know why delegate2.exe fails, it shouldn't
501 PLATFORM_DISABLED_TESTS+= delegate2.exe
502
503 # These tests newly fail with the latest revision. pinvoke3 fails because
504 # of a thread attach, the others have not been investigated.  TODO revisit.
505 PLATFORM_DISABLED_TESTS+= pinvoke3.exe \
506                           async_read.exe \
507                           async-with-cb-throws.exe \
508                           appdomain-unload-doesnot-raise-pending-events.exe \
509                           gsharing-valuetype-layout.exe
510
511 if X86
512 # FIXME: There are problems with async callbacks and results on NaCl 32-bit
513 PLATFORM_DISABLED_TESTS+= delegate1.exe \
514                           delegate3.exe \
515                           delegate5.exe \
516                           delegate8.exe \
517                           threadpool.exe \
518                           threadpool1.exe \
519                           threadpool-exceptions3.exe \
520                           bug-323114.exe \
521                           delegate-exit.exe \
522                           bug-80392.2.exe
523
524 # FIXME: These tests hang/fail for unknown reasons, deal with exiting
525 PLATFORM_DISABLED_TESTS+= main-returns-background-resetabort.exe \
526                           main-returns-background.exe \
527                           main-returns-background-change.exe
528 endif
529
530 endif
531
532 # The two finalizer tests only work under sgen
533 # gc-altstack.exe fails under boehm because it has no support for altstack
534 # bug-459094.exe creates an extremely deep directory tree
535 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
536 # reverted.
537 DISABLED_TESTS=                 \
538         delegate-async-exception.exe    \
539         bug-348522.2.exe        \
540         bug-459094.exe \
541         delegate-invoke.exe \
542         $(PLATFORM_DISABLED_TESTS)
543
544 DISABLED_TESTS_WRENCH=  \
545         $(DISABLED_TESTS)       \
546         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
547         main-returns-background-resetabort.exe \
548         main-returns-background-abort-resetabort.exe    \
549         main-returns-background.exe     \
550         thread6.exe     \
551         assemblyresolve_event3.exe \
552         delegate2.exe   \
553         finally_guard.exe       \
554         finalizer-abort.exe     \
555         finalizer-exit.exe      \
556         finalizer-thread.exe \
557         appdomain-async-invoke.exe
558
559 AOT_DISABLED_TESTS=constraints-load.exe
560
561 # These only compile with MS CSC
562 TEST_CSC_SRC=                   \
563         vararg.cs
564
565 TEST_IL_SRC=                    \
566         field-access.il         \
567         method-access.il        \
568         ldftn-access.il         \
569         cpblkTest.il            \
570         vbinterface.il          \
571         calliTest.il            \
572         ckfiniteTest.il         \
573         fault-handler.il                \
574         locallocTest.il         \
575         initblkTest.il          \
576         qt-instance.il          \
577         vararg.il               \
578         bug-29859.il            \
579         bug-78549.il            \
580         static-fields-nonconst.il       \
581         reload-at-bb-end.il     \
582         test-enum-indstoreil.il \
583         filter-bug.il           \
584         even-odd.il             \
585         bug-82022.il    \
586         vt-sync-method.il       \
587         enum_types.il   \
588         invalid-token.il        \
589         call_missing_method.il  \
590         call_missing_class.il   \
591         ldfld_missing_field.il  \
592         ldfld_missing_class.il  \
593         find-method.2.il        \
594         bug-79215.2.il  \
595         bug-79956.2.il  \
596         bug-327438.2.il \
597         bug-387274.2.il \
598         bug-426309.2.il \
599         ldtoken_with_byref_typespec.2.il \
600         resolve_method_bug.2.il \
601         resolve_field_bug.2.il \
602         resolve_type_bug.2.il   \
603         generics-sharing-other-exc.2.il \
604         generic-ldobj.2.il      \
605         generic-mkrefany.2.il   \
606         generic-refanyval.2.il  \
607         generic-ldtoken.2.il    \
608         generic-ldtoken-method.2.il     \
609         generic-ldtoken-field.2.il      \
610         generic-tailcall.2.il   \
611         generic-tailcall2.2.il  \
612         generic-array-exc.2.il  \
613         generic-valuetype-newobj2.2.il  \
614         generic-valuetype-newobj.2.il   \
615         generic-constrained.2.il        \
616         generic-type-load-exception.2.il        \
617         bug-81466.il    \
618         bug457574.il    \
619         bug445361.il    \
620         bug-463303.il   \
621         bug469742.2.il  \
622         bug-528055.il   \
623         constraints-load.il     \
624         array_load_exception.il \
625         bug-481403.il   \
626         interface-with-static-method.il \
627         bug-515884.il   \
628         bug-633291.il   \
629         delegate-with-null-target.il    \
630         bug-318677.il   \
631         gsharing-valuetype-layout.il    \
632         invalid_generic_instantiation.il
633
634
635 # pre-requisite test sources: files that are not test themselves
636 # but that need to be compiled
637 PREREQ_IL_SRC=event-il.il module-cctor.il
638 PREREQ_CS_SRC=
639 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
640 PREREQ_CS_DLL_SRC=
641
642 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
643 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
644 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
645 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
646 TESTBS=$(BENCHSRC:.cs=.exe)
647 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
648
649 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
650         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
651
652 %.exe: %.il
653         $(ILASM) -out:$@ $<
654
655 %.exe: %.cs TestDriver.dll
656         $(MCS) -r:TestDriver.dll -out:$@ $<
657
658 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
659 if POWERPC
660 test_platform:
661 else
662 # Can't use mkbundle on win32 since there is no static build there
663 # Can't run test-unhandled-exception on Windows because of all the debug popups...
664 if HOST_WIN32
665 test_platform:
666 else
667 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
668 #test_platform: testbundle test-iomap-regression
669 test_platform:  test-iomap-regression
670 endif
671 endif
672
673 if X86
674 if HOST_WIN32
675 else
676 test_platform: test-eglib-remap
677 endif
678 endif
679
680 # Target to precompile the test executables
681 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
682
683 #
684 # Test that no symbols are missed in eglib-remap.h
685 #
686 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
687 if NACL_CODEGEN
688 test-eglib-remap:
689 else
690 test-eglib-remap:
691         @echo "Testing eglib remap..."
692         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
693 endif
694
695 #
696 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
697 # code that checks that the table is properly sorted
698 #
699 if NACL_CODEGEN
700 test-messages:
701 else
702 test-messages: w32message.exe
703         > test_messages.zero
704         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
705 endif
706
707 if MOONLIGHT
708 test_2_1 : test-coreclr-security
709 else
710 test_2_1 :
711 endif
712
713 if AMD64
714 test-sgen : sgen-tests
715 else
716 if X86
717 test-sgen : sgen-tests
718 else
719 if ARM
720 test-sgen : sgen-tests
721 else
722 if S390x
723 test-sgen : sgen-regular-tests
724 endif
725 endif
726 endif
727 endif
728
729 test: assemblyresolve/test/asm.dll testjit test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
730 test-wrench: assemblyresolve/test/asm.dll testjit-wrench test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
731
732 # Remove empty .stdout and .stderr files for wrench
733 rm-empty-logs:
734         @echo "Removing empty logs..."
735         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
736
737 assemblyresolve/test/asm.dll:
738         $(MAKE) -C assemblyresolve prereq
739
740 TestDriver.dll:
741         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
742
743 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
744         @failed=0; \
745         passed=0; \
746         for i in $(TESTSI_CS); do       \
747                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
748                 then \
749                         passed=`expr $${passed} + 1`; \
750                 else \
751                         if [ $$? = 2 ]; then break; fi; \
752                         failed=`expr $${failed} + 1`; \
753                 fi \
754         done; \
755         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
756
757 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
758         @failed=0; \
759         passed=0; \
760         for i in $(TESTSI_IL); do       \
761                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" 'no-dump' $(RUNTIME_ARGS); \
762                 then \
763                         passed=`expr $${passed} + 1`; \
764                 else \
765                         if [ $$? = 2 ]; then break; fi; \
766                         failed=`expr $${failed} + 1`; \
767                 fi \
768         done; \
769         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
770
771 testb: $(TEST_PROG) $(TESTBS)
772         for i in $(TESTBS); do  \
773                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS);   \
774         done
775
776 runtest-wrench: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
777         @failed=0; \
778         passed=0; \
779         failed_tests="";\
780         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
781                 rm -f $${i}.so; \
782                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
783                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS_WRENCH)' 'dump-output' $(RUNTIME_ARGS); \
784                 then \
785                         passed=`expr $${passed} + 1`; \
786                 else \
787                         if [ $$? = 2 ]; then break; fi; \
788                         failed=`expr $${failed} + 1`; \
789                         failed_tests="$${failed_tests} $$i"; \
790                 fi \
791         done; \
792         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
793         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
794           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
795
796 runtest-managed-wrench: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
797         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS_WRENCH)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
798
799 testjit-wrench:
800         @if test x$(M) != x; then $(MAKE) runtest-managed-wrench; else $(MAKE) runtest-wrench; fi
801
802 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
803         @failed=0; \
804         passed=0; \
805         failed_tests="";\
806         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
807                 rm -f $${i}.so; \
808                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
809                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
810                 then \
811                         passed=`expr $${passed} + 1`; \
812                 else \
813                         if [ $$? = 2 ]; then break; fi; \
814                         failed=`expr $${failed} + 1`; \
815                         failed_tests="$${failed_tests} $$i"; \
816                 fi \
817         done; \
818         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
819         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
820           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
821
822 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
823         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
824
825 testjit:
826         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
827
828 testaot:
829         @$(MAKE) AOT=1 runtest
830
831 testtrace:
832         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
833
834 testinterp:
835         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
836
837 testjitspeed: $(JITTEST_PROG) $(TESTBS)
838         for i in $(TESTBS); do  \
839                 echo $$i;       \
840                 time $(JITTEST_PROG) $$i;       \
841         done
842
843 test-iomap-regression: exists.cs
844         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
845         @echo "Testing exists.exe..."
846         @MONO_IOMAP=all $(RUNTIME) exists.exe
847
848 stresstest: $(STRESS_TESTS)
849         @failed=0; \
850         passed=0; \
851         failed_tests="";\
852         for i in $(STRESS_TESTS); do    \
853                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
854                 then \
855                         passed=`expr $${passed} + 1`; \
856                 else \
857                         if [ $$? = 2 ]; then break; fi; \
858                         failed=`expr $${failed} + 1`; \
859                         failed_tests="$${failed_tests} $$i"; \
860                 fi \
861         done; \
862         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
863         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
864           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
865
866 testbundle: console.exe
867         @echo "Testing mkbundle..."
868         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
869         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
870         @- rm -rf a.out
871
872 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
873 test-type-load: TestDriver.dll
874         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
875         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
876         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
877         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
878         @echo "Testing load-exception.exe..."
879         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
880
881
882 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs sgen-weakref-stress.cs sgen-cementing-stress.cs sgen-case-23400.cs      finalizer-wait.cs critical-finalizers.cs
883
884
885 #those are actually configurations, eg plain_sgen-descriptors.exe
886 #DISABLE_SGEN_TESTS =
887
888 SGEN_TESTS =    \
889         finalizer-wait.exe      \
890         critical-finalizers.exe \
891         sgen-descriptors.exe    \
892         sgen-gshared-vtype.exe  \
893         sgen-domain-unload.exe  \
894         sgen-weakref-stress.exe \
895         sgen-cementing-stress.exe       \
896         sgen-case-23400.exe
897
898 SGEN_CONFIGURATIONS =   \
899         "|plain"        \
900         "major=marksweep-par|ms-par"    \
901         "major=marksweep-conc|ms-conc"  \
902         "major=marksweep-conc,minor=split|ms-conc-split"        \
903         "minor=split|ms-split"  \
904         "minor=split,alloc-ratio=95|ms-split-95"
905
906 #FIXME We should move to use SGEN_CONFIGURATIONS once sgen supports trailling commas or its argument list.
907 SGEN_BRIDGE_CONFIGURATIONS =    \
908         "|plain"        \
909         ",major=marksweep-conc|ms-conc" \
910         ",minor=split|ms-split"
911
912 sgen-regular-tests: $(SGEN_TESTS)
913         @failed=0; \
914         passed=0; \
915         failed_tests="";\
916         for test in $+; do      \
917                 echo "...$$test";       \
918                 for conf in $(SGEN_CONFIGURATIONS); do  \
919                         name=`echo $$conf | cut -d\| -f 2`;     \
920                         params=`echo $$conf | cut -d\| -f 1`;   \
921                         test_name="$${test}|$${name}";  \
922                         if MONO_GC_PARAMS="$$params" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);     \
923                         then \
924                                 passed=`expr $${passed} + 1`; \
925                         else \
926                                 if [ $$? = 2 ]; then break; fi; \
927                                 failed=`expr $${failed} + 1`; \
928                                 failed_tests="$${failed_tests} $$test_name"; \
929                         fi \
930                 done    \
931         done;   \
932         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
933         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
934           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
935
936 sgen-bridge-tests: sgen-bridge.exe sgen-bridge-major-fragmentation.exe
937         @failed=0; \
938         passed=0; \
939         failed_tests="";\
940         for test in $+; do      \
941                 echo "...$$test";       \
942                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
943                         name=`echo $$conf | cut -d\| -f 2`;     \
944                         params=`echo $$conf | cut -d\| -f 1`;   \
945                         test_name="$${test}|$${name}";  \
946                         if MONO_GC_PARAMS="bridge=Bridge$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);      \
947                         then \
948                                 passed=`expr $${passed} + 1`; \
949                         else \
950                                 if [ $$? = 2 ]; then break; fi; \
951                                 failed=`expr $${failed} + 1`; \
952                                 failed_tests="$${failed_tests} $$test_name"; \
953                         fi \
954                 done    \
955         done;   \
956         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
957         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
958           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
959
960 sgen-tests: sgen-regular-tests sgen-bridge-tests
961
962
963 # Generated tests for runtime invoke
964 EXTRA_DIST += gen-runtime-invoke.cs
965 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
966         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
967         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
968
969 EXTRA_DIST += make-imt-test.cs
970 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
971         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
972         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
973
974 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
975 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
976         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
977 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
978         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
979
980 EXTRA_DIST += unhandled-exception-base-configuration.config
981 EXTRA_DIST += unhandled-exception-legacy-configuration.config
982 EXTRA_DIST += appdomain-unload.exe.config
983 EXTRA_DIST += unhandled-exception-test-case.2.cs
984 EXTRA_DIST += unhandled-exception-test-runner.2.cs
985 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
986         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
987 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
988         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
989 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
990         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
991 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
992         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
993         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
994         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
995         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
996 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
997         $(MCS) /debug unhandled-exception-test-case.1.cs
998 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
999         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
1000 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
1001         $(MCS) /debug unhandled-exception-test-case.2.cs
1002 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
1003         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
1004 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
1005         $(MCS) /debug unhandled-exception-test-runner.2.cs
1006
1007 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
1008         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
1009
1010 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
1011 bug-80307.exe: $(srcdir)/bug-80307.cs
1012         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
1013         cd $(top_builddir)/runtime && $(MAKE) test-support-files
1014
1015 EXTRA_DIST += bug-81673-interface.cs
1016 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
1017         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1018         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
1019         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1020
1021 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
1022 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
1023         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
1024         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
1025         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
1026         rm -f bug-81691-a.dll
1027 bug-81691.exe: bug-81691-b.dll
1028
1029 EXTRA_DIST += bug-81466-lib.il
1030 bug-81466-lib.dll: bug-81466-lib.il
1031         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
1032 bug-81466.exe: bug-81466.il bug-81466-lib.dll
1033         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
1034
1035 EXTRA_DIST += bug-324535-il.il
1036 bug-324535-il.dll : bug-324535-il.il
1037         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
1038 bug-324535.exe : bug-324535.cs bug-324535-il.dll
1039         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
1040
1041 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
1042 custom-modifiers-lib.dll: custom-modifiers-lib.il
1043         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
1044 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
1045         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
1046
1047 EXTRA_DIST += bug-382986-lib.cs
1048 bug-382986-lib.dll: bug-382986-lib.cs
1049         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
1050 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
1051         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
1052
1053 EXTRA_DIST += coreclr-security.cs
1054
1055 if MOONLIGHT
1056 coreclr-security.exe : coreclr-security.cs
1057         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
1058
1059 test-coreclr-security : coreclr-security.exe
1060         @echo "Testing coreclr-security.exe..."
1061         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
1062 endif
1063
1064 EXTRA_DIST += generic-unboxing.2.il
1065 generic-unboxing.2.dll : generic-unboxing.2.il
1066         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
1067
1068 EXTRA_DIST += generic-boxing.2.il
1069 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
1070         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
1071
1072 EXTRA_DIST += generic-unbox.2.cs
1073 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
1074         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
1075
1076 EXTRA_DIST += generic-box.2.cs
1077 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
1078         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
1079
1080 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
1081 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
1082         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
1083 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
1084         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
1085
1086 bug-3903.exe: bug-3903.cs
1087         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
1088
1089 gshared: test-generic-sharing
1090
1091 gshared-aot:
1092         @$(MAKE) AOT=1 gshared
1093
1094 GSHARED_TESTS = \
1095                 generics-sharing.2.exe shared-generic-methods.2.exe     \
1096                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
1097                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
1098                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
1099                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
1100                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
1101                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
1102                 generic-virtual.2.exe generic-tailcall.2.exe                    \
1103                 generic-interface-methods.2.exe generic-array-type.2.exe        \
1104                 generic-method-patching.2.exe generic-static-methods.2.exe      \
1105                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
1106                 generic-array-exc.2.exe generic-special.2.exe                   \
1107                 generic-exceptions.2.exe generic-delegate2.2.exe                \
1108                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
1109                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
1110                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
1111                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
1112                 generic-constrained.2.exe bug-431413.2.exe                      \
1113                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
1114                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
1115                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
1116                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
1117                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
1118                 bug-479763.2.exe generic-xdomain.2.exe                          \
1119                 generic-type-load-exception.2.exe bug-616463.exe        \
1120                 bug-1147.exe
1121
1122 test-generic-sharing-normal: $(GSHARED_TESTS)
1123         @for fn in $+ ; do      \
1124                 echo "Testing $$fn ...";        \
1125                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
1126                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
1127                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
1128                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
1129                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
1130         done
1131
1132 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
1133         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
1134
1135 if NACL_CODEGEN
1136 test-generic-sharing:
1137 else
1138 test-generic-sharing:
1139         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
1140 endif
1141
1142 EXTRA_DIST += async-exceptions.cs
1143 async-exceptions.exe : async-exceptions.cs
1144         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1145 test-async-exceptions : async-exceptions.exe
1146         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1147         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1148
1149 EXTRA_DIST += modules.cs modules-m1.cs
1150 modules-m1.netmodule: modules-m1.cs
1151         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1152 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1153         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1154
1155 # Useful if mono is compiled with --enable-shared=no
1156 patch-libtool:
1157         cp "../../libtool" .
1158         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1159         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1160         touch libtest.c
1161
1162
1163 if NACL_CODEGEN
1164 test-process-exit:
1165 else
1166 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected threadpool-in-processexit.cs threadpool-in-processexit.exe.stdout.expected
1167 test-process-exit:
1168         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
1169         @echo "Testing bug-438454.exe..."
1170         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
1171         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
1172         @$(MCS) $(srcdir)/threadpool-in-processexit.cs -out:threadpool-in-processexit.exe
1173         @echo "Testing threadpool-in-processexit.exe..."
1174         @$(RUNTIME) threadpool-in-processexit.exe > threadpool-in-processexit.exe.stdout
1175         @diff -w threadpool-in-processexit.exe.stdout $(srcdir)/threadpool-in-processexit.exe.stdout.expected
1176 endif
1177
1178 OOM_TESTS =     \
1179         gc-oom-handling.exe     \
1180         gc-oom-handling2.exe
1181
1182
1183 test-oom: $(OOM_TESTS)
1184         @for fn in $+ ; do      \
1185                 echo "Testing $$fn ...";        \
1186                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1187                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1188                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1189         done
1190
1191
1192 noinst_LTLIBRARIES = libtest.la
1193
1194 AM_CPPFLAGS = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
1195
1196 if HOST_WIN32
1197 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1198 # This shows up when compiling mono_test_marshal_delegate ()
1199 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1200 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1201 # can't find them. So we use --kill-at to remove the @ suffix as well.
1202 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1203 else
1204 libtest_la_LDFLAGS = -rpath `pwd`
1205 endif
1206 libtest_la_SOURCES = libtest.c
1207 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1208
1209 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat